#include "interpreter.h"

/*
#define dprintf

void UnixSetupFunc()
{    
}

void Ctest (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    dprintf("test(%d)\n", Param[0]->Val->Integer);
    Param[0]->Val->Integer = 1234;
}

void Clineno (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = Parser->Line;
}
*/

#include <propeller.h>

void PropellerSetupFunc()
{    
}

void CHigh (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = 0;
    OUTA |= 1 << Param[0]->Val->Integer;
}

void CLow (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = 0;
    OUTA &= ~(1 << Param[0]->Val->Integer);
}

void COutput (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = 0;
    DIRA |= 1 << Param[0]->Val->Integer;
}

void CInput (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = 0;
    DIRA &= ~(1 << Param[0]->Val->Integer);
}

void CPin (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    int pin = Param[0]->Val->Integer;
    ReturnValue->Val->Integer = (INA & (1 << pin)) >> pin;
}

void CPins (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = INA;
}

void CCtra (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    CTRA = Param[0]->Val->Integer;
}

void CFrqa (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    FRQA = Param[0]->Val->Integer;
}

void CPhsa (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    PHSA = Param[0]->Val->Integer;
}

void CCtrb (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    CTRB = Param[0]->Val->Integer;
}

void CFrqb (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    FRQB = Param[0]->Val->Integer;
}

void CPhsb (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    PHSB = Param[0]->Val->Integer;
}

void CCnt (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = CNT;
}

void CClkfreq (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = CLKFREQ;
}

void CWaitcnt (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    ReturnValue->Val->Integer = waitcnt2(Param[0]->Val->Integer,Param[1]->Val->Integer);
}

void CWaitpeq (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    waitpeq(Param[0]->Val->Integer,Param[1]->Val->Integer);
}

void CWaitpne (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    waitpne(Param[0]->Val->Integer,Param[1]->Val->Integer);
}

void CVcfg (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    VCFG = Param[0]->Val->Integer;
}

void CVscl (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    VSCL = Param[0]->Val->Integer;
}

void CWaitvid (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    waitvid(Param[0]->Val->Integer,Param[1]->Val->Integer);
}


/* list of all library functions and their prototypes */
struct LibraryFunction PropellerFunctions[] =
{
/*  
    { Ctest,        "void test(int);" },
    { Clineno,      "int lineno();" },
*/    
    { CHigh,        "void high(int);" },
    { CLow,         "void low(int);" },
    { COutput,      "void output(int);" },
    { CInput,       "void input(int);" },
    { CPin,         "int  pin(int);" },
    { CPins,        "int  pins();" },
    { CCtra,        "void ctra(int);" },
    { CFrqa,        "void frqa(int);" },
    { CPhsa,        "void phsa(int);" },
    { CCtrb,        "void ctrb(int);" },
    { CFrqb,        "void frqb(int);" },
    { CPhsb,        "void phsb(int);" },
    
    { CCnt,         "int  cnt();" },
    { CClkfreq,     "int  clkfreq();" },
    { CWaitcnt,     "int  waitcnt(int,int);" },
    { CWaitpeq,     "void waitpeq(int,int);" },
    { CWaitpne,     "void waitpne(int,int);" },

    { CVcfg,        "void vcfg(int);" },
    { CVscl,        "void vscl(int);" },
    { CWaitvid,     "void waitvid(int,int);" },

    { NULL,         NULL }
};

void PlatformLibraryInit()
{
    IncludeRegister("propeller.h", &PropellerSetupFunc, &PropellerFunctions[0], NULL);
}